//
// Here we define local references to objects and methods
// in the toplevel frame. This is for ease of use, and to
// avoid duplicate definitions at run time. (No need to
// parse the functions for every page load, or have 2 copies
// of an array of strings in memory.)
//
// OK, so the booleans (g_bRunningAsXXX) are copied by value,
// not reference, but they never change so it's ok.
//
// See ibarmgr.js for actual definitions of these.
//
// CAUTION: Functions execute in the scope in which they
// are defined. Need to be careful when writing them.
// For example, if ErrorHandler were defined in nusrmgr.js,
// then it would have to use "idContent.event.foo" instead
// of "window.event.foo".
//


var PopulateLeftPane    = top.window.PopulateLeftPane;
var g_Navigator         = top.window.g_Navigator;


function ErrorHandler(szMsg)
{
    alert(szMsg);
    event.returnValue = true;
}

// Since this is a web page the user can select elements on the
// page. Since this is an app, selecting element is undesireable.
// Therefore we catch the start of a selection event and cancel it.
function OnSelectStart()
{
    // We still want to be able to select text in entry fields though.
    if (!event.srcElement.isTextEdit)
        event.returnValue = false;
}

function PageInit()
{
  window.onerror = ErrorHandler;

  var szRelatedTaskContent = null;
  var szLearnAboutContent = idLearnAboutContent.innerHTML;
  var szDescription = idDescription.innerHTML;

  fnBuildTable();

  PopulateLeftPane(szRelatedTaskContent, szLearnAboutContent, szDescription);
}

